﻿Imports System.Data.OleDb

'C1
Imports C1.Win.C1FlexGrid

Public Class Form2
    Dim SqlStr As String = ""
    Private OleDbdataSet As DataSet

    Private Sub Form2_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Try
            DGLaden()

        Catch ex As Exception
            MsgBox("Error 'Form2_Load' : " & vbCrLf & ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub DGLaden()
        Try
            C1FlexGrid1.DataSource = Nothing
            C1FlexGrid1.Rows.RemoveRange(1, C1FlexGrid1.Rows.Count - 1)

            SqlStr = "SELECT ID, showImage, statuseng FROM status ORDER BY ID"
            Dim conn As String = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\temp\tImage.mdb;User Id=admin;Password=;"
            Dim OleDbda As New OleDb.OleDbDataAdapter(SqlStr, conn)
            OleDbdataSet = New DataSet
            OleDbda.Fill(OleDbdataSet, "IListe")
            Dim dt As DataTable = OleDbdataSet.Tables("IListe")
            C1FlexGrid1.DataSource = dt
            'Formatting C1FlexGrid
            With C1FlexGrid1
                .Cols(1).Caption = "ID"         'ID
                .Cols(1).Width = 100

                .Cols(2).Caption = "Image"      'showImage
                '.Cols(2).Width = 200
                .Cols(2).WidthDisplay = 200

                .Cols(3).Caption = "Text"       'statuseng
                .Cols(3).Width = 180
            End With

            C1FlexGrid1.DrawMode = C1.Win.C1FlexGrid.DrawModeEnum.OwnerDraw
            AddHandler C1FlexGrid1.OwnerDrawCell, AddressOf C1FlexGrid1_OwnerDrawCell

        Catch ex As Exception
            MsgBox("Error 'DGLaden' : " & vbCrLf & ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Sub

    Sub C1FlexGrid1_OwnerDrawCell(sender As Object, e As C1.Win.C1FlexGrid.OwnerDrawCellEventArgs)
        Try
            If (e.Col).Equals(2) AndAlso e.Row > 0 Then
                e.Image = GetImageFromByteArray(TryCast(C1FlexGrid1(e.Row, e.Col), [Byte]()))
                'e.Style.ImageAlign = C1.Win.C1FlexGrid.ImageAlignEnum.Stretch
                e.Style.Display = C1.Win.C1FlexGrid.DisplayEnum.ImageOnly
            End If

        Catch ex As Exception
            MsgBox("Error 'C1FlexGrid1_OwnerDrawCell' : " & vbCrLf & ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Function GetImageFromByteArray(picData As Byte()) As Image
        Try
            If (picData) Is Nothing Then
                Return Nothing
            End If

            '' is this is an embedded object
            Dim bmData As Integer = If((picData(0) = 21 AndAlso picData(1) = 28), 78, 0)

            '' load the picture    
            Dim img As Image = Nothing
            Try
                Dim ms As New System.IO.MemoryStream(picData, bmData, picData.Length - bmData)
                img = Image.FromStream(ms)
            Catch
            End Try
            '' return what we got  

            Return img

        Catch ex As Exception
            MsgBox("Error 'GetImageFromByteArray' : " & vbCrLf & ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Function
End Class