﻿Imports C1.Win.C1FlexGrid
Imports System.Data.OleDb
Imports System.IO

Public Class Form1

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Try
            'Dim conn As String = GetConnectionString()
            Dim conn As String = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\temp\tImage.mdb;User Id=admin;Password=;"
            Dim rs As String = "Select ID, showImage, statuseng from Status"
            Dim da As OleDbDataAdapter = New OleDbDataAdapter(rs, conn)
            Dim ds As New DataSet()
            da.Fill(ds)
            C1FlexGrid1.DataSource = ds.Tables(0)
            C1FlexGrid1.Rows.DefaultSize = 100
            C1FlexGrid1.Rows(0).HeightDisplay = 21
            C1FlexGrid1.Cols(2).WidthDisplay = 100
            C1FlexGrid1.DrawMode = DrawModeEnum.OwnerDraw

        Catch ex As Exception
            MsgBox("Error 'Form1_Load' : " & vbCrLf & ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Sub

    Sub C1FlexGrid1_OwnerDrawCell(sender As Object, e As OwnerDrawCellEventArgs) Handles C1FlexGrid1.OwnerDrawCell
        Try
            If (e.Col).Equals(2) AndAlso e.Row > 0 Then
                e.Image = GetImageFromByteArray(TryCast(C1FlexGrid1(e.Row, e.Col), [Byte]()))
                e.Style.ImageAlign = ImageAlignEnum.Stretch
                e.Style.Display = DisplayEnum.ImageOnly
            End If

        Catch ex As Exception
            MsgBox("Error 'C1FlexGrid1_OwnerDrawCell' : " & vbCrLf & ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Function GetImageFromByteArray(picData As Byte()) As Image
        Try
            If (picData) Is Nothing Then
                Return Nothing
            End If

            Dim bmData As Integer = If((picData(0) = 21 AndAlso picData(1) = 28), 78, 0)

            Dim img As Image = Nothing
            Try
                Dim ms As New System.IO.MemoryStream(picData, bmData, picData.Length - bmData)
                img = Image.FromStream(ms)
            Catch
            End Try
            Return img

        Catch ex As Exception
            MsgBox("Error 'GetImageFromByteArray' : " & vbCrLf & ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Function

    Private Function GetConnectionString() As String
        Try
            Dim path As String = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + "\ComponentOne Samples\Common"
            'Dim conn As String = "provider=microsoft.jet.oledb.4.0;data source={0}\c1nwind.mdb;"
            Dim conn As String = "provider=microsoft.jet.oledb.4.0;data source=C:\temp\tImage.mdb;"

            Return String.Format(conn, path)

        Catch ex As Exception
            MsgBox("Error 'GetConnectionString' : " & vbCrLf & ex.ToString, MsgBoxStyle.Critical)
        End Try
    End Function
End Class